import xs from "xstream";
declare type Component<So, Pr, Si> = (sources: So, props: Pr) => Si;
declare type Si<T> = {
    [P in keyof T]: xs<T[P]>;
};
export declare function pickMerge<T, P extends keyof T>(sink_list: Si<T>[], prop: P): xs<T[P]>;
export declare function pickCombine<T, P extends keyof T>(sink_list: Si<T>[], prop: P): xs<T[P][]>;
declare type MergeAll<T> = {
    [P in keyof T]: xs<T[P]>;
};
declare type CombineAll<T> = {
    [P in keyof T]: xs<T[P][]>;
};
interface Lot<T> {
    merge: MergeAll<T>;
    combine: CombineAll<T>;
}
export declare const Collection: typeof Lot;
interface LotOptions<So, Pr, T> {
    component: Component<So, Pr, Si<T>>;
    sources: So;
    add$: xs<Pr | Pr[]>;
    reset$?: xs<any>;
    remove_prop?: keyof T;
}
export declare function Lot<So, Pr, T>(options: LotOptions<So, Pr, T>): Lot<T>;
export {};
